=== debian/changelog ===
libcgns (4.2.0-1~exp1) experimental; urgency=medium

  * Ne upstream release
  * Drop patch gcc-pr92361.patch (fixed upstream)
  * Bump soname 4.1 -> 4.2
  * Update symbols file

 -- Gilles Filippini <pini@debian.org>  Thu, 13 May 2021 00:24:53 +0200
