=== debian/control ===
Source: libcgns
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gilles Filippini <pini@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11~),
               dh-exec,
               tk-dev,
               libglu1-mesa-dev,
               libxmu-dev,
               gfortran,
               libhdf5-dev,
               chrpath,
               cmake
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/libcgns.git
Vcs-Git: https://salsa.debian.org/science-team/libcgns.git
Homepage: https://cgns.github.io

Package: libcgns-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         libcgns4.2 (= ${binary:Version}),
         ${misc:Depends}
Description: CFD General Notation System library
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.
 .
 This package contains the development files needed to compile software to
 use the libcgns API.

Package: libcgns4.2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: CFD General Notation System library
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.

Package: cgns-convert
Architecture: any
Section: science
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: CFD General Notation System - Conversion tools
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.
 .
 This package contains the adf2hdf, hdf2adf tools.
